//+------------------------------------------------------------------+
//|                                           FXA0 - Ladderv0.02.mq4 |
//|                            Copyright  2007 Adam J. Richter M.S. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Adam J. Richter M.S."
#property link      ""

/*
   TODO: Mulitiple Timeframes 5, 15, 30 and H1 
    uses H4 for entry, but needs to verify if also entry on H1, just uses H1 for clos
    News filter: enabled; FromHourTrade=0; ToHourTrade=12;
*/
double TakeProfit = 8;
double Lots = 0.1;
double InitialStop = 0;

extern int PipStep=15;
int mm=0;  //money management, will add this later
int risk=12;  //only used if mm=1
int AccountType=0;  // 0 if Normal Lots, 1 for mini lots, 2 for micro lots
extern int MagicNumber = 888888; //added

int rsi_period = 0; //0 is current period
int MaxTrades=2;
extern int     StopTrade               = 13;
extern int     StartTrade              = 18;


int ticket;
int marketQualityValue=0;
int  OpenOrders=0, cnt=0;
int  slippage=5;
double tp=0;
double sl=0;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
int lastType=0;
bool ContinueOpening=True;
int  PreviousOpenOrders=0;
double Profit=0;
int LastTicket=0, LastType=0;
double LastPrice=0, LastLots=0;
double PipValue=0;
string text="", text2="";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| value added functions                                            |
//+------------------------------------------------------------------+

//add quality points to go long, subtract quality points to go short
int marketQuality() 
{
	int QualityPoints=0;
	
	if(iRSI(NULL,0,21,PRICE_CLOSE,0)>50 && iRSI(NULL,0,21,PRICE_CLOSE,0)>iRSI(NULL,0,21,PRICE_CLOSE,1)) { QualityPoints=1; } //go long
	if(iRSI(NULL,0,21,PRICE_CLOSE,0)<50 && iRSI(NULL,0,21,PRICE_CLOSE,0)<iRSI(NULL,0,21,PRICE_CLOSE,1)) { QualityPoints=2; } //go short


	//val0>0, val1>0, val2==2147483647 //go long - blue
	//if(iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,2,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)==2147483647) {QualityPoints=1;}//go long
   //   val0>0, val1==2147483647, val2>0  //go short - red
	//if(iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,2,0)!=2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)!=2147483647) {QualityPoints=2;}//go short
   //val0>0, val1==2147483647, val2==2147483647 //yellow - sideways
	//if(iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,2,0)==2147483647 || iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)==2147483647) {QualityPoints=5;}//sideways
	
	/*double downa=iCustom(NULL,PERIOD_H4,"xpMA",0,0,0);
	double downb=iCustom(NULL,PERIOD_H4,"xpMA",0,1,0);
	double downc=iCustom(NULL,PERIOD_H4,"xpMA",0,2,0);
	double downd=iCustom(NULL,PERIOD_H4,"xpMA",0,3,0);
	Print("1: " + downa + "  2: " + downb + "  3: " + downc + "4: " + downd);*/
	
	//if(iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,0,0)!=0 && iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,1,0)==0) {QualityPoints=1;}//go long
	//if(iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,0,0)==0 && iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,1,0)!=0) {QualityPoints=2;}//go short

   //if(iCustom(NULL,PERIOD_H4,"xpMA",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,2,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==0) {QualityPoints=1;}//go long
	//if(iCustom(NULL,PERIOD_H4,"xpMA",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,2,0)==2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==0) {QualityPoints=2;}//go short
   //if(iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==1 || iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==-1) { QualityPoints=5; }  
	return(QualityPoints);
}

int closeQuality() 
{
	int QualityPoints=0;
	
	if(iRSI(NULL,PERIOD_H4,21,PRICE_CLOSE,0)>50 && iRSI(NULL,PERIOD_H4,21,PRICE_CLOSE,0)>iRSI(NULL,PERIOD_H4,21,PRICE_CLOSE,1)) { QualityPoints=1; } //go long
	if(iRSI(NULL,PERIOD_H4,21,PRICE_CLOSE,0)<50 && iRSI(NULL,PERIOD_H4,21,PRICE_CLOSE,0)<iRSI(NULL,PERIOD_H4,21,PRICE_CLOSE,1)) { QualityPoints=2; } //go short

	//if(iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)==2147483647) {QualityPoints=1;}//go long
   //if(iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)!=2147483647) {QualityPoints=2;}//go short
	//if(iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)==2147483647) {QualityPoints=5;}//sideways
	
   //if(iCustom(NULL,PERIOD_H1,"Waddah_Attar_Trend",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H1,"Waddah_Attar_Trend",0,2,0)==2147483647) {QualityPoints=1;}//go long
   //if(iCustom(NULL,PERIOD_H1,"Waddah_Attar_Trend",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"Waddah_Attar_Trend",0,2,0)!=2147483647) {QualityPoints=2;}//go short
	
	//if(iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,0,0)!=0 && iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,1,0)==0) {QualityPoints=1;}//go long
	//if(iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,0,0)==0 && iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,1,0)!=0) {QualityPoints=2;}//go short

   //if(iCustom(NULL,PERIOD_H4,"xpMA",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,2,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==0) {QualityPoints=1;}//go long
	//if(iCustom(NULL,PERIOD_H4,"xpMA",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,2,0)==2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==0) {QualityPoints=2;}//go short
   //if(iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==1 || iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==-1) { QualityPoints=5; }
	return(QualityPoints);
}

void CloseAllOrders()
{
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	   if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
      {
         if (OrderType()==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow); }
         if (OrderType()==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow); }
      }
   }
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
//----
   if (AccountType==0){ if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000); } else { lotsi=Lots; } } 
   if (AccountType==1){ if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/10; } else { lotsi=Lots; } }
   if (AccountType==2){ if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/100; } else { lotsi=Lots; } }
   if (lotsi<0.01) lotsi=0.01;
   if (lotsi>100) lotsi=100; 
   
   PipValue=MarketInfo(Symbol(),16);
   if (PipValue==0) { PipValue=1; }
   
  //finds current profit on last opened order, last type of order and the total number of open orders
  lastType=0;
  OpenOrders=0; 
  Profit=0; LastTicket=0; LastPrice=0; LastLots=0;	
  for(cnt=0;cnt<OrdersTotal();cnt++)
  {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
      {            
          Profit += OrderProfit();       
          OpenOrders ++; 
          if(OrderTicket() > LastTicket)
          {
              LastTicket = OrderTicket();
              LastPrice = OrderOpenPrice();
              LastLots = OrderLots();
              if (OrderType()==OP_BUY) { lastType=1; }
              if (OrderType()==OP_SELL) { lastType=2; }
          }   
       }
  }   
   
   marketQualityValue=0;
  //-Check trading Time
  if (Hour()>StopTrade && Hour()<StartTrade) 
  {Comment("No trading time!");
  return(0);}//End of trading time check
   marketQualityValue=closeQuality();
   //close profitable orders
   if(OpenOrders>=1)
   {
      if(Profit>=TakeProfit) { CloseAllOrders(); Print("Closed for Profit "); }  
      //close orders if market changes in opposite direction
      if(lastType==1 && marketQualityValue==2) { CloseAllOrders(); Print("Closed for Change from Buy to Sell"); }
      if(lastType==2 && marketQualityValue==1) { CloseAllOrders(); Print("Closed for Change from Sell to Buy"); }
      
      //close if sideways or yellow if using trend histo
      if((lastType==1 || lastType==2) && marketQualityValue==5) { CloseAllOrders(); Print("Closed for Sideways Market"); }
   }
   
      
   if (OpenOrders>=MaxTrades) 
   { ContinueOpening=False; } 
   else { ContinueOpening=True; }
   
   marketQualityValue=0;
   if(OpenOrders==0)
   {
      marketQualityValue=marketQuality();
      if(marketQualityValue==1)
      {
         ticket=OrderSend(Symbol(),OP_BUY,lotsi,Ask,slippage,sl,0,"Ladder Long Order",MagicNumber,0,Blue);
         if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Long Order: ",OrderOpenPrice()); }
         else Print("Error opening Ladder Long Order:  Lots " + lotsi,GetLastError());
         return(0);
      }
      if(marketQualityValue==2)
      {
         ticket=OrderSend(Symbol(),OP_SELL,lotsi,Bid,slippage,sl,0,"Ladder Short Order",MagicNumber,0,Red);
         if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Short Order: ",OrderOpenPrice()); }
         else Print("Error opening Ladder Short Order:  Lots " + lotsi,GetLastError());
         return(0);
      }
      if(marketQualityValue==5)
      {
        //Print("No market to open"); 
      }
   }
   
   ticket=0;
   if(OpenOrders>=1 && ContinueOpening && lastType==1 && ((LastPrice-Ask)>=PipStep*Point))
   {
      LastLots=LastLots*2;
      ticket=OrderSend(Symbol(),OP_BUY,LastLots,Ask,slippage,sl,0,"Ladder Long Order",MagicNumber,0,Blue);
      if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Long Order: ",OrderOpenPrice()); }
      else Print("Error opening Ladder Long Order:  Lots " + lotsi,GetLastError());
      //open another long position
   }
   
   if(OpenOrders>=1 && ContinueOpening && lastType==2 && ((Bid-LastPrice)>=PipStep*Point))
   {
      LastLots=LastLots*2;
      ticket=OrderSend(Symbol(),OP_SELL,LastLots,Bid,slippage,sl,0,"Ladder Short Order",MagicNumber,0,Red);
      if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Short Order: ",OrderOpenPrice()); }
      else Print("Error opening Ladder Short Order:  Lots " + lotsi,GetLastError());
      //open another short position
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


